#ifndef __CLOTH_VISUALIZER_HXX
#define __CLOTH_VISUALIZER_HXX
/*----------------------------------------------------------------------------------------------------*/
#include "colliding_cloth.hxx"
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCoordinate3.h>

class VisualCloth : public CollidingCloth {
  SoCoordinate3 *visual_coords;

public:
  void draw(void);  

  const SbVec3f& operator()(size_t x, size_t y) const;
  SoSeparator* generate(void);
};

extern inline const SbVec3f&  VisualCloth::operator()(size_t x, size_t y) const {
  return Cloth::get_masspoint(x,y);
}
/*----------------------------------------------------------------------------------------------------*/
#endif
