#ifndef __COLLIDING_CLOTH_HXX
#define __COLLIDING_CLOTH_HXX
/*----------------------------------------------------------------------------------------------------*/
#include "cloth.hxx"

class CollidingCloth : public Cloth {
public:
  struct ColliderTriangle {
    SbVec3f center; /* mass center of triangle */
    int indexes[3]; /* indexes of corner vertices */
    SbVec3f c_rel[3]; /* corners as center relative vectors */
    SbVec3f side[2]; /* diff vectors between corners, relative to vertices[indexes[0]] */
  };

private:
  /*
    Test two triangles per vertex:
    i, i+1, i+x_max()
    and
    i, i-1, i-x_max()
    this gives 2*(y-1)*(x-1) Triangles since boundary vertices
    don't have certain triangles
  */
  
  void init(void);
  void recompute_trias(void);

  ColliderTriangle *trias;
  size_t nof_trias;

  bool do_collide(const ColliderTriangle &c, const ColliderTriangle &test, int idx);
public:
  void update(void);
  CollidingCloth(void);
};

/*----------------------------------------------------------------------------------------------------*/
#endif
